package cn.com.qmth.examcloud.core.basic.api.controller;

import cn.com.qmth.examcloud.api.commons.security.bean.User;
import cn.com.qmth.examcloud.api.commons.security.enums.RoleMeta;
import cn.com.qmth.examcloud.commons.exception.StatusException;
import cn.com.qmth.examcloud.core.basic.service.CryptoConfigService;
import cn.com.qmth.examcloud.core.basic.service.bean.CryptoConfigInfo;
import cn.com.qmth.examcloud.web.support.ControllerSupport;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

@RestController
@Api(tags = "加密方案组合配置相关接口")
@RequestMapping("${$rmp.ctr.basic}/crypto/config")
public class CryptoConfigController extends ControllerSupport {

    @Autowired
    private CryptoConfigService cryptoConfigService;

    @PostMapping("/list")
    @ApiOperation(value = "获取所有组合配置列表")
    public List<CryptoConfigInfo> list() {
        return cryptoConfigService.getAllCryptoConfigs();
    }

    @PostMapping("/update")
    @ApiOperation(value = "启用、禁用某些组合")
    public void update(@RequestBody List<CryptoConfigInfo> cryptoConfigs) {
        User accessUser = getAccessUser();
        if (!hasAnyRoles(accessUser, RoleMeta.SUPER_ADMIN, RoleMeta.ORG_ADMIN)) {
            throw new StatusException("500403", "没有数据操作权限！");
        }

        cryptoConfigService.updateCryptoConfigs(cryptoConfigs);
    }

}
