package cn.com.qmth.examcloud.core.basic.api.provider;

import cn.com.qmth.examcloud.core.basic.api.CryptoConfigCloudService;
import cn.com.qmth.examcloud.core.basic.api.request.CheckCryptoConfigReq;
import cn.com.qmth.examcloud.core.basic.api.response.CheckCryptoConfigResp;
import cn.com.qmth.examcloud.core.basic.service.CryptoConfigService;
import cn.com.qmth.examcloud.web.support.ControllerSupport;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

@RestController
@Api(tags = "RPC-加密方案组合配置相关接口")
@RequestMapping("${$rmp.cloud.basic}/crypto/config")
public class CryptoConfigCloudProvider extends ControllerSupport implements CryptoConfigCloudService {

    @Autowired
    private CryptoConfigService cryptoConfigService;

    @Override
    @PostMapping("/check")
    @ApiOperation(value = "判断某个组合是否启用")
    public CheckCryptoConfigResp checkCryptoConfig(@RequestBody CheckCryptoConfigReq req) {
        boolean enable = cryptoConfigService.isEnableCryptoCombination(req.getCombination());
        return new CheckCryptoConfigResp(enable);
    }

}
