package cn.com.qmth.examcloud.core.basic.base.util;

public class BaseUtil {

    /**
     * 密码规则：至少包含大写字母、小写字母、数字、符号中的三种，密码长度限制在6-10位
     */
    public static final String reg = "^(?![a-zA-Z]+$)(?![A-Z0-9]+$)(?![A-Z\\W_]+$)(?![a-z0-9]+$)(?![a-z\\W_]+$)(?![0-9\\W_]+$)[a-zA-Z0-9\\W_]{6,10}$";

    public static boolean checkPassword(String str) {
        return check(str, reg);
    }

    public static boolean check(String str, String reg) {
        if (str != null && str.matches(reg)) {
            return true;
        }
        return false;
    }

}
