package cn.com.qmth.examcloud.core.basic.dao;

import cn.com.qmth.examcloud.core.basic.dao.entity.OrgEntity;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.JpaSpecificationExecutor;
import org.springframework.data.repository.query.QueryByExampleExecutor;

import java.util.List;
import java.util.Set;

/**
 * Created by songyue on 17/1/13.
 */
public interface OrgRepo extends JpaRepository<OrgEntity, Long>,
        QueryByExampleExecutor<OrgEntity>,
        JpaSpecificationExecutor<OrgEntity> {

    List<OrgEntity> findByRootId(Long rootId);

    OrgEntity findByParentIdIsNullAndDomainName(String domainName);

    OrgEntity findByRootIdAndCode(Long rootId, String code);

    List<OrgEntity> findByRootIdAndNameLike(Long rootId, String name);

    OrgEntity findByParentIdIsNullAndCode(String code);

    OrgEntity findByParentIdIsNullAndId(Long id);

    int countByRootIdAndNameLike(Long rootId, String name);

    int countByRootIdAndParentId(Long rootId, long parentId);

    List<OrgEntity> findByIdIn(Set<Long> orgIds);

    List<OrgEntity> findByParentId(Long rootOrgId);

}
