package cn.com.qmth.examcloud.core.basic.service;

import cn.com.qmth.examcloud.core.basic.service.bean.CryptoConfigInfo;

import java.util.List;

/**
 * 加密方案组合配置相关接口
 */
public interface CryptoConfigService {

    /**
     * 初始化默认组合配置
     */
    void initCryptoConfigs();

    /**
     * 获取所有组合配置列表
     */
    List<CryptoConfigInfo> getAllCryptoConfigs();

    /**
     * 启用、禁用某些组合
     */
    void updateCryptoConfigs(List<CryptoConfigInfo> cryptoConfigs);

    /**
     * 判断某个组合是否启用
     */
    boolean isEnableCryptoCombination(String combination);

    /**
     * 按用户随机获取一个组合
     */
    String randomCryptoCombination(Long userId);

}
