package cn.com.qmth.examcloud.core.basic.service.cache;

import cn.com.qmth.examcloud.core.basic.dao.ThirdPartyAccessRepo;
import cn.com.qmth.examcloud.core.basic.dao.entity.ThirdPartyAccessEntity;
import cn.com.qmth.examcloud.core.basic.dao.entity.ThirdPartyAccessPK;
import cn.com.qmth.examcloud.support.CacheConstants;
import cn.com.qmth.examcloud.support.cache.bean.ThirdPartyAccessCacheBean;
import cn.com.qmth.examcloud.web.cache.RandomObjectRedisCache;
import cn.com.qmth.examcloud.web.helpers.GlobalHelper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Service
public class ThirdPartyAccessCache extends RandomObjectRedisCache<ThirdPartyAccessCacheBean> {

    @Autowired
    ThirdPartyAccessRepo thirdPartyAccessRepo;

    @Override
    public ThirdPartyAccessCacheBean loadFromResource(Object... keys) {
        Long rootOrgId = (Long) keys[0];
        String appId = (String) keys[1];

        ThirdPartyAccessEntity entity = GlobalHelper.getEntity(thirdPartyAccessRepo,
                new ThirdPartyAccessPK(rootOrgId, appId), ThirdPartyAccessEntity.class);

        ThirdPartyAccessCacheBean bean = new ThirdPartyAccessCacheBean();

        if (null == entity) {
            bean.setHasValue(false);
            return bean;
        }

        bean.setAppId(entity.getAppId());
        bean.setRootOrgId(entity.getRootOrgId());
        bean.setSecretKey(entity.getSecretKey());
        bean.setTimeRange(entity.getTimeRange());

        return bean;
    }

    @Override
    protected String getKeyPrefix() {
        return CacheConstants.CACHE_B_THIRD_PARTY_ACCESS;
    }

    @Override
    protected int getTimeout() {
        // 5分钟
        return 60 * 5;
    }

}
